VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} labeler 
   Caption         =   "Labeler"
   ClientHeight    =   3855
   ClientLeft      =   120
   ClientTop       =   465
   ClientWidth     =   3255
   OleObjectBlob   =   "labeler.frx":0000
   ShowModal       =   0   'False
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "Labeler"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private CancelLabelTextBox As Boolean
Private LabelCount As Long
Private AddressCount As Long
Private CurrentAddress As Range

Private Sub LabelAllButton_Click()
    Dim Found As Boolean
    Dim SkipRow As Boolean
    VBATime True
    With Code_Sheet
        Dim LastRow As Long: LastRow = .Cells(.Rows.Count, AddressCol).End(xlUp).Row
        Dim i As Long
        For i = 1 To LastRow
            SkipRow = False
            If i > 2 Then
                If Len(.Cells(i - 1, CodeCol).Value2) = 0 Then SkipRow = True 'Do not label jumps/branches without data in the previous row
            End If
            If Not SkipRow Then
                Scan_Address (.Cells(i, AddressCol))
                If AddressCount > 0 Then
                    Found = True
                    CurrentAddress = Code_Sheet.Cells(i, AddressCol)
                    Scan_Address CurrentAddress
                    Dim NewLabel As String
                    NewLabel = Code_Sheet.Cells(i, RefCol).Value2
                    If Len(NewLabel) = 0 Then
                        Save "", True
                    Else
                        Save NewLabel, False
                    End If
                End If
            End If
        Next i
        If Not Found Then MsgBox "No address references were found."
        Exit Sub
    End With
    VBATime False
End Sub

Private Sub RandomizeButton_Click()
    Save "", True
    If Me.FindNextOnEnter.Value Then
        FindNextAddressRef
    Else
        Update_Displayed_Text
    End If
End Sub

Private Sub UserForm_Initialize()
    Scan_Address Selection
    Update_Displayed_Text
End Sub

Private Sub AddressDisplay_Click()
    Code_Sheet.Range(Me.AddressDisplay.Caption).Select
End Sub

Private Sub Scan_Address(CodeAddress As Range)
    Set CurrentAddress = Code_Sheet.Cells(CodeAddress.Row, AddressCol)
    LabelCount = 0
    AddressCount = 0
    Dim SearchLabel As String
    With Code_Sheet
        SearchLabel = Code_Sheet.Cells(CurrentAddress.Row, RefCol).Value2
        If Len(SearchLabel) Then
            Dim SearchRange As Range
            Set SearchRange = .UsedRange
            Dim FoundLabels As Range
            Set FoundLabels = SearchRange.Find(SearchLabel, LookIn:=xlValues, LookAt:=xlPart)
            If Not FoundLabels Is Nothing Then
                strFirstAddress = FoundLabels.Address
                Dim RegEx As Object, MyString As String
                Set RegEx = CreateObject("VBScript.RegExp")
            
                With RegEx
                  .Pattern = LabelPattern
                End With
                Do
                    Set FoundLabels = SearchRange.FindNext(FoundLabels)
                    
                    Dim RegExMatches As Object
                    Set RegExMatches = RegEx.Execute(FoundLabels.Value2)
                     
                     
                    For Each RegExMatch In RegExMatches
                        If RegExMatch = SearchLabel Then LabelCount = LabelCount + 1
                    Next
                Loop While Not FoundLabels Is Nothing And FoundLabels.Address <> strFirstAddress
                LabelCount = LabelCount - 1
            End If
        End If
        If CurrentAddress.Column = RefCol Or CurrentAddress.Column = AddressCol Then
            Dim SingleLabel As Boolean: SingleLabel = False
            Dim Dependents As Variant: Dependents = Null
            On Error Resume Next
            Set Dependents = Code_Sheet.Cells(CurrentAddress.Row, AddressCol).DirectDependents
            On Error GoTo 0
            If Not IsNull(Dependents) Then
                Dim cell As Range
                For Each cell In Dependents
                    If cell.Column = CodeCol Then
                        AddressCount = AddressCount + 1
                    End If
                Next cell
            End If
        End If
    End With
End Sub

Private Sub Update_Displayed_Text()
    Dim SearchLabel As String
    SearchLabel = Code_Sheet.Cells(CurrentAddress.Row, RefCol).Value2
    Me.AddressDisplay.Caption = Replace(Code_Sheet.Cells(CurrentAddress.Row, AddressCol).Address, "$", "")
    Me.MemoryAddressDisplay.Caption = Code_Sheet.Cells(CurrentAddress.Row, AddressCol).Value2
    
    If LabelCount = 0 Then
        Me.LabelRefCount.Caption = ""
        Me.Label.Text = ""
    Else
        Me.LabelRefCount.Caption = LabelCount & " @Label References"
    End If
    If Len(SearchLabel) > 0 Then
        If Left(SearchLabel, 1) = "@" Then
            Me.Label.Text = Mid(SearchLabel, 2)
        Else
            Me.Label.Text = SearchLabel
        End If
    End If

    If AddressCount = 0 Then
        Me.AddressRefCount.Caption = ""
    Else
        Me.AddressRefCount.Caption = AddressCount & " Address References"
    End If
End Sub

Private Sub FindNextAddressRef()
    With Code_Sheet
        Dim StartRow As Long: StartRow = Selection.Row
        Dim LastRow As Long: LastRow = .Cells(.Rows.Count, AddressCol).End(xlUp).Row
        Dim i As Long
        For i = StartRow + 1 To LastRow
            Scan_Address (.Cells(i, AddressCol))
            If AddressCount > 0 Then GoTo Found
        Next i
        For i = 1 To StartRow
            Scan_Address (.Cells(i, AddressCol))
            If AddressCount > 0 Then GoTo Found
        Next i
        MsgBox "No address references were found."
        Exit Sub
    End With
Found:
        Update_Displayed_Text
        Code_Sheet.Cells(i, AddressCol).Select
        Me.Label.SetFocus
End Sub

Private Sub FindButton_Click()
    FindNextAddressRef
End Sub

Private Sub CheckButton_Click()
    Scan_Address Selection
    Update_Displayed_Text
    Me.Label.SetFocus
End Sub

Private Sub Save(Optional NewLabel As String = "", Optional Rand As Boolean = False)

    Dim CharacterBank As Variant
    CharacterBank = Array("a", "b", "c", "d", "e", "f", "g", "h", "i", "j", _
      "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", _
      "y", "z")
  
    If NewLabel = "" And Label.Text = "" And Rand = False Then Exit Sub
    With Code_Sheet
        Dim OldLabel As String: OldLabel = .Cells(CurrentAddress.Row, RefCol).Value2
        If Rand Then
            Do
                NewLabel = "@rlabel_"
                Dim j As Integer
                For j = 0 To 3
                    Randomize
                    NewLabel = NewLabel & CharacterBank(Int((UBound(CharacterBank) - LBound(CharacterBank) + 1) * Rnd + LBound(CharacterBank)))
                Next j
                Dim Match As Long: Match = 0
                On Error Resume Next
                Match = Application.WorksheetFunction.Match(Label, Code_Sheet.Cells(1, RefCol).EntireColumn, 0)
                On Error GoTo 0
            Loop While Match <> 0
        Else
            NewLabel = "@" & Label.Text
        End If
        Label_Branch_Or_Jump CurrentAddress, OldLabel, NewLabel
    End With
    CancelLabelTextBox = True
End Sub

Private Sub Label_Enter()
    CancelLabelTextBox = False
End Sub

Private Sub Label_Exit(ByVal Cancel As MSForms.ReturnBoolean)
    If CancelLabelTextBox Then
        Cancel = True
        CancelLabelTextBox = False
    End If
End Sub

Private Sub Label_KeyDown(ByVal KeyCode As MSForms.ReturnInteger, ByVal Shift As Integer)
    If KeyCode = vbKeyReturn Then
        Call Save
        Update_Displayed_Text
        If Me.FindNextOnEnter.Value Then
            FindNextAddressRef
        End If
    End If
End Sub

Private Sub SaveButton_Click()
    Call Save
    If Me.FindNextOnEnter.Value Then
        FindNextAddressRef
    Else
        Update_Displayed_Text
    End If
End Sub





